#include <formatio.h>
#include <rs232.h>
/*---------------------------------------------------------------------------*/
/*                                                                           */
/* FILE:    server.c                                                         */
/*                                                                           */
/* PURPOSE: This is a skeleton program to demonstrate how you would write a  */
/*          a TCP Server application. This sample registers a server on a    */
/*          speciable port number and waits for connections.  It will allow  */
/*          a connection from one client, and let the user send data back    */
/*          and forth.  For simplicity, the server refuses more than 1       */
/*          simultaneous client connection.                                  */
/*                                                                           */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Include files                                                             */
/*---------------------------------------------------------------------------*/
#include <cvirte.h>
#include <stdio.h>
#include <stdlib.h>
#include <tcpsupp.h>
#include <string.h>
#include <utility.h>
#include <userint.h>
#include "server.h"

/*---------------------------------------------------------------------------*/
/* Internal function prototypes                                              */
/*---------------------------------------------------------------------------*/
int CVICALLBACK ServerTCPCB (unsigned handle, int event, int error,
                             void *callbackData);

/*---------------------------------------------------------------------------*/
/* Module-globals                                                            */
/*---------------------------------------------------------------------------*/
static unsigned int g_hconversation;
static int          g_hmainPanel;

static int fileHandle;

char logFileName[MAX_PATHNAME_LEN]="datalog.txt";


int user_connected=0;
int critical=0;	//sygnalizacja wejscia w sekcje krytyczna

/*---------------------------------------------------------------------------*/
/* This is the application's entry-point.                                    */
/*---------------------------------------------------------------------------*/
int main (int argc, char *argv[])
{
    int      portNum;
    char     tempBuf[256] = {0};
	char textbuf[60]; 

    if (InitCVIRTE (0, argv, 0) == 0)
        return -1;
    if ((g_hmainPanel = LoadPanel(0, "server.uir", MAINPNL)) < 0)
        return -1;
    DisableBreakOnLibraryErrors();

    /* Prompt for the port number on which to receive connections */
    //PromptPopup ("Numer portu",
    //             "Wpisz numer portu na ktorym uruchomiona\n\nma zostac usluga. Domyslny port: 7777\n.",
    //             tempBuf, 31);
    
    //portNum = atoi (tempBuf);
	//if(portNum<=0) portNum=7777;
	portNum=7777;
    /* Attempt to register as a TCP server... */
    SetWaitCursor (1);
    if (RegisterTCPServer (portNum, ServerTCPCB, 0) < 0)
        MessagePopup("TCP Server", "Server registration failed!");
    else
        {
        SetWaitCursor (0);
        
        /* We are successfully registered -- gather info */
        SetCtrlVal (g_hmainPanel, MAINPNL_ONLINE, 1);
        GetTCPHostAddr (tempBuf, 256);
        SetCtrlVal (g_hmainPanel, MAINPNL_SERVER_IP, tempBuf);
        GetTCPHostName (tempBuf, 256);
        SetCtrlVal (g_hmainPanel, MAINPNL_SERVER_NAME, tempBuf);
        SetCtrlAttribute (g_hmainPanel, MAINPNL_STRING, ATTR_DIMMED, 1);
        SetCtrlVal (g_hmainPanel, MAINPNL_CONNECTED, 0); 
        
        OpenComConfig (1, "", 9600, 0, 8, 1, 100, 100);
		
		fileHandle = OpenFile (logFileName, VAL_READ_WRITE, VAL_APPEND,VAL_ASCII);
		//loguj wlaczenie serwera
		WriteFile (fileHandle, "\n\nServer started:", strlen("\n\nServer started:")); 
		CopyString (textbuf, 0, DateStr(), 0, 11);	//wrzucenie lancucha daty do bufora
		WriteFile (fileHandle, "  Date: ", strlen("  Date: "));
		WriteFile (fileHandle, textbuf, strlen(textbuf));
        CopyString (textbuf, 0, TimeStr(), 0, strlen(TimeStr()));
		WriteFile (fileHandle, "   Time: ", strlen("   Time: ")); 
		WriteFile (fileHandle, textbuf, strlen(textbuf));
		WriteFile (fileHandle, "  ", strlen("  ")); 
			
        
        /* Display the panel and run the UI */
        DisplayPanel (g_hmainPanel);
        SetActiveCtrl (g_hmainPanel, MAINPNL_STRING);
        RunUserInterface ();
        CloseCom (1);
        if(fileHandle!=-1)
		{
		CloseFile (fileHandle);
		}

        /* Unregister the TCP server */
        UnregisterTCPServer (portNum);
        }
    
    /* Free resources and return */
    DiscardPanel (g_hmainPanel);
    CloseCVIRTE ();
    return 0;
}

/*---------------------------------------------------------------------------*/
/* When the user hits ENTER after typing some text, send it to the client... */
/* Note that the string control will be dimmed unless there is a client      */
/* connected.                                                                */
/*---------------------------------------------------------------------------*/
int CVICALLBACK TransmitCB (int panelHandle, int controlID, int event,
                            void *callbackData, int eventData1, int eventData2)
{
    char transmitBuf[512] = {0};

    switch (event)
        {
        case EVENT_COMMIT:
            GetCtrlVal (panelHandle, MAINPNL_STRING, transmitBuf);
            strcat (transmitBuf, "\n");
            SetCtrlVal (panelHandle, MAINPNL_TRANSMIT, transmitBuf);
            SetCtrlVal (panelHandle, MAINPNL_STRING, "");
            if (ServerTCPWrite (g_hconversation, transmitBuf,
                                strlen (transmitBuf) + 1, 1000) < 0)
                SetCtrlVal (panelHandle, MAINPNL_TRANSMIT,
                            "Transmit Error\n");
            break;
        }
    return 0;
}

char tabuf[60];
char tabuf2[60];
void SendTemperature(void)
	{
	
	char textbuf[200];
	char nowybuf[20];
	char znak[2]="C";
	int queue,i,j;
	static int count=0;	
	if(GetInQLen(1)>0&&critical==0)
				{
				critical=1;
				queue = GetInQLen (1);	//get input queue length
				for(i=0;i<60;i++) tabuf[i]=0;
				for(i=0;i<60;i++) tabuf2[i]=0;
				
				ComRdTerm (1, tabuf, 13, 0);
	            FlushInQ (1);
				for(i=0;i<60;i++) tabuf2[i]=tabuf[i];
				
				SetCtrlVal (g_hmainPanel, MAINPNL_STRING_2, tabuf);
				//ServerTCPWrite (g_hconversation, tabuf2,strlen (tabuf2) + 1, 1000); 
				//pasek tutulu!!!!!
				SetPanelAttribute (g_hmainPanel, ATTR_TITLE, tabuf);
				
				j = strcspn (tabuf, znak);
				//j = strchr (tabuf, 'C');
				strcpy (nowybuf, tabuf);
				nowybuf[j+1]=0;	//uzupelnienie null-em
				SetSystemAttribute(ATTR_TASKBAR_BUTTON_TEXT, nowybuf);
				
				critical=0;
				}		
			if(user_connected==1)
				{
				if(strlen(tabuf)>0)
					{
					ServerTCPWrite (g_hconversation, tabuf,strlen (tabuf), 1000);
					for(i=0;i<60;i++) tabuf[i]=0;
	                }	
				count++;	
				
				if(count>10)	//zmiana komentarza do logu
						{
						count=0;
						CopyString (textbuf, 0, TimeStr(), 0, strlen(TimeStr()));
						WriteFile (fileHandle, "Time: ", strlen("Time: ")); 
						WriteFile (fileHandle, textbuf, strlen(textbuf));
						WriteFile (fileHandle, "  ", strlen("  ")); 
						//GetTCPHostName (textbuf, 199); 
						GetTCPPeerName (g_hconversation, textbuf, 180); 
                
						WriteFile (fileHandle, textbuf, strlen(textbuf));
						WriteFile (fileHandle, "  ", strlen("  ")); 
						GetTCPPeerAddr (g_hconversation, textbuf, 31);
                		WriteFile (fileHandle, textbuf, strlen(textbuf));
                		WriteFile (fileHandle, "\n", strlen("\n")); 
						}
						
				}
	}

int CVICALLBACK TimerCallback (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{

	switch (event)
		{
		case EVENT_TIMER_TICK:
			SendTemperature();
			break;
		}
	return 0;
}



/*---------------------------------------------------------------------------*/
/* This is the TCP server's TCP callback.  This function will receive event  */
/* notification, similar to a UI callback, whenever a TCP event occurs.      */
/* We'll respond to CONNECT and DISCONNECT messages and indicate to the user */
/* when a client connects to or disconnects from us.  when we have a client  */
/* connected, ee'll respond to the DATAREADY event and read in the avaiable  */
/* data from the client and display it.                                      */
/*---------------------------------------------------------------------------*/
int CVICALLBACK ServerTCPCB (unsigned handle, int event, int error,
                             void *callbackData)
{
    int  dataSize         = 10;		//bylo 256
    char receiveBuf[256] = {0};
    char addrBuf[200];
	char tbuf[200];
	char textbuf[60];
	
	//int temp;
	int readSize=0;
	 int k;  
    switch (event)
        {
        case TCP_CONNECT:					 //algorytm z wywlaszczaniem
            if (g_hconversation)
                {
				//rozlaczenie starego klienta
				CopyString (tbuf, 0, "\n\r\n\rPrzykro mi, polaczenie zostalo przerwane - inny klient korzysta z serwera.\n\rSprobuj polaczyc sie ponownie za chwile.\n\r", 0, 180);
                ServerTCPWrite (g_hconversation, tbuf,strlen (tbuf) + 1, 1000);
				DisconnectTCPClient (g_hconversation);
                }
                /*
                // We already have one client, don't accept another... 
                GetTCPPeerAddr (handle, addrBuf, 31);
                sprintf (receiveBuf, "-- Refusing conection request from "
                                     "%s --\n", addrBuf); 
                SetCtrlVal (g_hmainPanel, MAINPNL_RECEIVE, receiveBuf);
                DisconnectTCPClient (handle);
                }
            else
                {
                */
				Beep ();
                
                /* Handle this new client connection */
                g_hconversation = handle;
                SetCtrlVal (g_hmainPanel, MAINPNL_CONNECTED, 1);
                GetTCPPeerAddr (g_hconversation, addrBuf, 31);
                SetCtrlVal (g_hmainPanel, MAINPNL_CLIENT_IP, addrBuf);
                GetTCPPeerName (g_hconversation, receiveBuf, 256);
                SetCtrlVal (g_hmainPanel, MAINPNL_CLIENT_NAME, receiveBuf);
                sprintf (receiveBuf, "\n-- New connection from %s --\n",addrBuf); 
                SetCtrlVal (g_hmainPanel, MAINPNL_RECEIVE, receiveBuf);
                SetCtrlAttribute (g_hmainPanel, MAINPNL_STRING, ATTR_DIMMED,0);
                
				//ekran powitalny
				//SendTemperature();	//wyrzucenie pierwszego wyniku pomiaru od razu
				
				//k=0;
				//while(k==0)
				//	{
				//	if(strlen(tabuf)>0)
				//		{
						//ServerTCPWrite (g_hconversation, tabuf,strlen (tabuf) + 1, 1000); 
				//		k=1;
				//		}
				//	}
				
				
				ServerTCPWrite (g_hconversation, tabuf2,strlen (tabuf2) + 1, 1000); 
				//SetPanelAttribute (g_hmainPanel, ATTR_TITLE, tabuf);
				
				
				
				CopyString (tbuf, 0, "Eksperymentalny serwer temperatury na parapecie.\n\r", 0, 60);
				ServerTCPWrite (g_hconversation, tbuf,strlen (tbuf) + 1, 1000);
				CopyString (tbuf, 0, "Model: single client z wywlaszczaniem - polaczenie\n\rzostanie przerwane jezeli inny klient bedzie probowal sie dolaczyc.\n\r", 0, 180);
				ServerTCPWrite (g_hconversation, tbuf,strlen (tbuf) + 1, 1000);
				
				CopyString (tbuf, 0, "(c) Tomasz Ostrowski 2005\n\r", 0, 40);
				ServerTCPWrite (g_hconversation, tbuf,strlen (tbuf) + 1, 1000);
				
				
				//nazwa dns (raczej uzytkownika SO?!?) klienta
				CopyString (tbuf, 0, "\n\rWitaj, ", 0, 40);
                //GetTCPHostName (addrBuf, 199);
                GetTCPPeerName (g_hconversation, addrBuf, 180); 
                CopyString (tbuf, strlen(tbuf), addrBuf, 0, 80);
                ServerTCPWrite (g_hconversation, tbuf,strlen (tbuf) + 1, 1000);
                ServerTCPWrite (g_hconversation, "!\n\r",strlen ("!\n\r") + 1, 1000);
                
                //adres ip klienta
                CopyString (tbuf, 0, "IP klienta: ", 0, 40);
                GetTCPPeerAddr (g_hconversation, addrBuf, 31);
                CopyString (tbuf, strlen(tbuf), addrBuf, 0, 40);
                ServerTCPWrite (g_hconversation, tbuf,strlen (tbuf) + 1, 1000);
                ServerTCPWrite (g_hconversation, "\n\r\n\r",strlen ("\n\r\n\r") + 1, 1000);
                
                CopyString (tbuf, 0, "Odswiezanie wyniku pomiaru: co 5s.\n\rOpcja chatu - wyslij znak o kodzie 255\n\raby zasygnalizowac beeperem chec rozmowy.\n\rKonwersacja poprzez interfejs klienta telnetu.\n\r", 0, 180);
                ServerTCPWrite (g_hconversation, tbuf,strlen (tbuf) + 1, 1000);
                
                CopyString (tbuf, 0, "Sygnalizacja dzwiekowa po stronie serwera mozliwa jest co 5s.\n\r", 0, 180);
                ServerTCPWrite (g_hconversation, tbuf,strlen (tbuf) + 1, 1000);
                
                CopyString (tbuf, 0, "Aby wyslac znak o kodzie 255 (dotyczy windows) wcisnij i przytrzymaj\n\rlewy alt wpisujac 255 z klawiatury numerycznej.\n\r", 0, 180);
                ServerTCPWrite (g_hconversation, tbuf,strlen (tbuf) + 1, 1000);
                
                
                CopyString (tbuf, 0, "Uwagi ogolne: putty wymaga zatwierdzania wszystkich\n\rwysylanych komunikatow enterem, MS telnet wysyla je natychmiast.\n\r\n\r\n\r", 0, 160);
                ServerTCPWrite (g_hconversation, tbuf,strlen (tbuf) + 1, 1000);
                
                
                //logowanie do pliku
                CopyString (textbuf, 0, DateStr(), 0, 11);	//wrzucenie lancucha daty do bufora
				WriteFile (fileHandle, "\nDate: ", strlen("\nDate: "));
				WriteFile (fileHandle, textbuf, strlen(textbuf));
				
                CopyString (textbuf, 0, TimeStr(), 0, strlen(TimeStr()));
				WriteFile (fileHandle, "   Time: ", strlen("   Time: ")); 
				WriteFile (fileHandle, textbuf, strlen(textbuf));
				WriteFile (fileHandle, "  ", strlen("  ")); 
				//GetTCPHostName (addrBuf, 199); 
				GetTCPPeerName (g_hconversation, addrBuf, 180); 
                
				WriteFile (fileHandle, addrBuf, strlen(addrBuf));
				WriteFile (fileHandle, "  ", strlen("  ")); 
				GetTCPPeerAddr (g_hconversation, textbuf, 31);
           		WriteFile (fileHandle, textbuf, strlen(textbuf));
           		WriteFile (fileHandle, "\n", strlen("\n")); 
                
                user_connected=1; 
                /* Set the disconect mode so we do not need to terminate */
                /* connections ourselves. */
                SetTCPDisconnectMode (g_hconversation, TCP_DISCONNECT_AUTO);
                SendTemperature();	//wyrzucenie pierwszego wyniku pomiaru od razu
				ResetTimer (g_hmainPanel, MAINPNL_TIMER);	//zeby bylo kulturalnie
                
                //}
            break;
        case TCP_DATAREADY:
            if ((readSize = ServerTCPRead (g_hconversation, receiveBuf,dataSize, 1000) ) < 0)
                SetCtrlVal (g_hmainPanel, MAINPNL_RECEIVE, "Receive Error\n");
            else
                {
                SetCtrlVal (g_hmainPanel, MAINPNL_RECEIVE, receiveBuf);
				//logowanie do pliku
				WriteFile (fileHandle, receiveBuf, strlen(receiveBuf));
           		//WriteFile (fileHandle, "\n", strlen("\n")); 
                
				if(critical==0)	//wejscie w sekcje krytyczna
					{
					critical=1;
					//ComWrt(1, smallBuf, 20);
					ComWrt (1, receiveBuf, 10);	//wrzucenie do COM bufora
                	critical=0;
                	}
                }
            break;
        case TCP_DISCONNECT:
            if (handle == g_hconversation)
                {
                user_connected=0;
                
                /* The client we were talking to has disconnected... */
                SetCtrlVal (g_hmainPanel, MAINPNL_CONNECTED, 0);
                g_hconversation = 0;
                SetCtrlVal (g_hmainPanel, MAINPNL_CLIENT_IP, "");
                SetCtrlVal (g_hmainPanel, MAINPNL_CLIENT_NAME, "");
                SetCtrlVal (g_hmainPanel, MAINPNL_RECEIVE,
                            "\n-- Client disconnected --\n");
                SetCtrlAttribute (g_hmainPanel, MAINPNL_STRING, ATTR_DIMMED,
                                  1);
                
                /* Note that we do not need to do any more because we set the*/
                /* disconnect mode to AUTO. */
                }
            break;
    }
    return 0;
}

/*---------------------------------------------------------------------------*/
/* Respond to the UI and clear the receive screen for the user.              */
/*---------------------------------------------------------------------------*/
int CVICALLBACK ClearScreenCB (int panel, int control, int event,
                               void *callbackData, int eventData1,
                               int eventData2)
{
    if (event == EVENT_COMMIT)
        ResetTextBox (panel, MAINPNL_RECEIVE, "");
    return 0;
}

int CVICALLBACK ClearScreenTR (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			ResetTextBox (panel, MAINPNL_TRANSMIT, "");
			break;
		}
	return 0;
}


/*---------------------------------------------------------------------------*/
/* Respond to the panel closure to quit the UI loop.                         */
/*---------------------------------------------------------------------------*/
int CVICALLBACK MainPanelCB (int panel, int event, void *callbackData,
                             int eventData1, int eventData2)
{
    if (event == EVENT_CLOSE)
        QuitUserInterface (0);
    return 0;
}

